unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, EditBtn, FileCtrl,
  StdCtrls, LCLIntf;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonOpen: TButton;
    ButtonRefresh: TButton;
    ButtonDelete: TButton;
    ButtonClose: TButton;
    ButtonLowerCase: TButton;
    ButtonFindReplace: TButton;
    ButtonUpperCase1: TButton;
    ButtonRename: TButton;
    ButtonSelectAll: TButton;
    ButtonAbout: TButton;
    DirectoryEdit1: TDirectoryEdit;
    FileListBox1: TFileListBox;
    procedure ButtonOpenClick(Sender: TObject);
    procedure ButtonAboutClick(Sender: TObject);
    procedure ButtonCloseClick(Sender: TObject);
    procedure ButtonDeleteClick(Sender: TObject);
    procedure ButtonFindReplaceClick(Sender: TObject);
    procedure ButtonLowerCaseClick(Sender: TObject);
    procedure ButtonRefreshClick(Sender: TObject);
    procedure ButtonRenameClick(Sender: TObject);
    procedure ButtonSelectAllClick(Sender: TObject);
    procedure ButtonUpperCase1Click(Sender: TObject);
    procedure DirectoryEdit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject);

  private

  public

  const

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.ButtonSelectAllClick(Sender: TObject);
begin
     FileListBox1.SelectAll;
end;

procedure TForm1.ButtonUpperCase1Click(Sender: TObject);
var
   I:integer;
   S: string;
   T: string;
begin
   for i := 0 to filelistbox1.Items.Count -1 do
   begin
        if filelistbox1.Selected[i] = true then
        begin
             S := filelistbox1.Items.Strings[i];
             T := uppercase(S);
             S := DirectoryEdit1.directory + '/' + S;
             filelistbox1.Items.Strings[i] := T;
             T := DirectoryEdit1.directory + '/' + T;
             if RenameFile(S,T) then;
        end;
   end;

end;

procedure TForm1.ButtonRenameClick(Sender: TObject);
var
   I: Integer;
   S: string;
   T: string;
begin
   I := filelistbox1.ItemIndex;
   S := filelistbox1.Items.Strings[I];
   T := InputBox('Input','New name',S);
   if T = '' then exit;
   if T = S then exit;
   S := DirectoryEdit1.directory + '/' + S;
   filelistbox1.Items.Strings[I] := T;
   T := DirectoryEdit1.directory + '/' + T;
   if RenameFile(S,T) then;
end;

procedure TForm1.ButtonFindReplaceClick(Sender: TObject);
var
   I: integer;
   F: string;
   R: string;
   S: string;
   T: string;
begin
     F := inputbox('Find','Text to find:','');
     R := inputbox('Replace','New text:',F);
     for i := 0 to filelistbox1.Items.Count -1 do
     begin
          if filelistbox1.Selected[i] = true then
          begin
              S := filelistbox1.Items.Strings[i];
              T := StringReplace(S,F,R,[rfReplaceAll]);
              S := DirectoryEdit1.directory + '/' + S;
              filelistbox1.Items.Strings[i] := T;
              T := DirectoryEdit1.directory + '/' + T;
              if RenameFile(S,T) then;
          end;
     end;
end;

procedure TForm1.ButtonLowerCaseClick(Sender: TObject);
var
   I: integer;
   S: string;
   T: string;
begin
   for i := 0 to filelistbox1.Items.Count -1 do
   begin
        if filelistbox1.Selected[i] = true then
        begin
            S := filelistbox1.Items.Strings[i];
            T := lowercase(S);
            S := DirectoryEdit1.directory + '/' + S;
            filelistbox1.Items.Strings[i] := T;
            T := DirectoryEdit1.directory + '/' + T;
            if RenameFile(S, T) then;
        end;
   end;
end;

procedure TForm1.ButtonRefreshClick(Sender: TObject);
begin
     filelistbox1.UpdateFileList;
end;

procedure TForm1.ButtonAboutClick(Sender: TObject);
begin
     ShowMessage('galen@currah.us, 4 April 2021.' + Chr(13) +
     'Compiled in FreePascal 3.0.2' + Chr(13) +
     'Close button saves directory name');
end;

procedure TForm1.ButtonOpenClick(Sender: TObject);
var
  I: Integer;
  S: String;
begin
  I := filelistbox1.ItemIndex;
  S := filelistbox1.Items.Strings[I];
  S := filelistbox1.Directory + '/' + PChar(S);
  if OpenDocument(S) then;
end;

procedure TForm1.ButtonCloseClick(Sender: TObject);
var
      S: string;
      F: textfile;
begin
   try
       AssignFile(F, 'FileHelper.ini');
       rewrite(F);
       S := DirectoryEdit1.Directory;
       writeln(F,S);
       CloseFile(F);
   except
   end;
   halt (1);
end;

procedure TForm1.ButtonDeleteClick(Sender: TObject);
var
   B: boolean = False;
   I:integer;
   S: string;
begin
   i := 3;
   i := application.messagebox('Really?','Delete selected files?',i);
   if i = 6 then
   begin
       for i := filelistbox1.Items.Count -1 downto 0 do
       begin
            if filelistbox1.Selected[i] = true then
            begin
                 S := filelistbox1.items[i];
                 S := filelistbox1.Directory + '/' + S;
                 B := deletefile(S);
            end;
       end;
       filelistbox1.UpdateFileList;
   end;
end;

procedure TForm1.DirectoryEdit1Change(Sender: TObject);
begin
     FileListBox1.Directory := DirectoryEdit1.Directory;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
      S: string;
      F: TextFile;
begin
      try
          S := 'FileHelper.ini';
          if fileexists(S) then
          begin
          AssignFile(F, S);
          reset(F);
          readln(F, S);
          DirectoryEdit1.Directory := S;
          CloseFile(F);
          end;
      except
      end;
      left := 400;
      top := 200;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
     filelistbox1.Width := buttonselectall.left - 40;
end;

procedure TForm1.FormClose(Sender: TObject);
var
      S: string;
      F: textfile;
begin
   try
       AssignFile(F, 'FileHelper.ini');
       rewrite(F);
       S := DirectoryEdit1.Directory;
       writeln(F,S);
       CloseFile(F);
   except
   end;
end;

end.

